"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var t = _ref.types;

  return {
    visitor: {
      ExpressionStatement: function ExpressionStatement(path) {
        var first = path.node;
        var newExpression = void 0;
        var promiseIdentifier = void 0;
        var args = void 0;
        if (first.type === 'ExpressionStatement') {
          if (first.expression.type === 'NewExpression') {
            newExpression = first.expression;
            if (newExpression.callee && newExpression.callee.type === 'Identifier' && newExpression.callee.name === 'Promise') {
              promiseIdentifier = newExpression.callee;
              args = newExpression.arguments;
              var newNode = generateAst(args);
              path.replaceWith(newNode);
            }
          }
        }
      }
    }
  };
};

var _babelTemplate = require("babel-template");

var _babelTemplate2 = _interopRequireDefault(_babelTemplate);

var _babelGenerator = require("babel-generator");

var _babelGenerator2 = _interopRequireDefault(_babelGenerator);

var _babelTypes = require("babel-types");

var t = _interopRequireWildcard(_babelTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var buildRequire = (0, _babelTemplate2.default)("\n  $q(FUNCTION);\n");

function generateAst(node) {
  var args = node[0];
  var func = void 0;

  if (t.isArrowFunctionExpression(args)) {
    func = t.arrowFunctionExpression(args.params, args.body, false);
  } else if (t.isFunctionExpression(args)) {
    func = t.functionExpression(args.id, args.params, args.body, args.generator, args.async);
  }

  return buildRequire({
    FUNCTION: func
  });
}